com.fasterxml.jackson.databind.deser.impl

## Class InnerClassProperty

- java.lang.Object
- - com.fasterxml.jackson.databind.introspect.ConcreteBeanPropertyBase
  - - com.fasterxml.jackson.databind.deser.SettableBeanProperty
    - - com.fasterxml.jackson.databind.deser.impl.InnerClassProperty

All Implemented Interfaces:
  BeanProperty, Named, Serializable

    public final class InnerClassProperty
    extends SettableBeanProperty

This sub-class is used to handle special case of value being a non-static inner class. If so, we will have to use a special alternative for default constructor; but otherwise can delegate to regular implementation.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from interface com.fasterxml.jackson.databind.BeanProperty

`BeanProperty.Std`

### Field Summary

Fields
`protected AnnotatedConstructor` `_annotated` Serializable version of single-arg constructor we use for value instantiation.
`protected Constructor<?>` `_creator` Constructor used when deserializing this property.
`protected SettableBeanProperty` `_delegate` Actual property that we use after value construction.

### Fields inherited from class com.fasterxml.jackson.databind.deser.SettableBeanProperty

`_contextAnnotations, _managedReferenceName, _objectIdInfo, _propertyIndex, _propName, _type, _valueDeserializer, _valueTypeDeserializer, _viewMatcher, _wrapperName, MISSING_VALUE_DESERIALIZER`

### Fields inherited from class com.fasterxml.jackson.databind.introspect.ConcreteBeanPropertyBase

`_metadata, _propertyFormat`

### Fields inherited from interface com.fasterxml.jackson.databind.BeanProperty

`EMPTY_FORMAT, EMPTY_INCLUDE`

### Constructor Summary

Constructors
`protected` `InnerClassProperty(InnerClassProperty src, AnnotatedConstructor ann)` Constructor used with JDK Serialization; needed to handle transient Constructor, wrap/unwrap in/out-of Annotated variant.
`protected` `InnerClassProperty(InnerClassProperty src, JsonDeserializer<?> deser)`
`protected` `InnerClassProperty(InnerClassProperty src, PropertyName newName)`
`` `InnerClassProperty(SettableBeanProperty delegate, Constructor<?> ctor)`

### Method Summary

Methods
`void` `deserializeAndSet(JsonParser jp, DeserializationContext ctxt, Object bean)` Method called to deserialize appropriate value, given parser (and context), and set it using appropriate mechanism.
`Object` `deserializeSetAndReturn(JsonParser jp, DeserializationContext ctxt, Object instance)` Alternative to `SettableBeanProperty.deserializeAndSet(com.fasterxml.jackson.core.JsonParser, com.fasterxml.jackson.databind.DeserializationContext, java.lang.Object)` that returns either return value of setter method called (if one is), or null to indicate that no return value is available.
`void` `fixAccess(DeserializationConfig config)` Method called to ensure that the mutator has proper access rights to be called, as per configuration.
`<A extends Annotation> A` `getAnnotation(Class<A> acls)` Method for finding annotation associated with this property; meaning annotation associated with one of entities used to access property.
`AnnotatedMember` `getMember()` Method for accessing primary physical entity that represents the property; annotated field, method or constructor property.
`void` `set(Object instance, Object value)` Method called to assign given value to this property, on specified Object.
`Object` `setAndReturn(Object instance, Object value)` Method called to assign given value to this property, on specified Object, and return whatever delegating accessor returned (if anything)
`InnerClassProperty` `withName(PropertyName newName)` Fluent factory method for constructing and returning a new instance with specified property name.
`InnerClassProperty` `withValueDeserializer(JsonDeserializer<?> deser)` Fluent factory method for constructing and returning a new instance with specified value deserializer.

### Methods inherited from class com.fasterxml.jackson.databind.deser.SettableBeanProperty

`_throwAsIOE, _throwAsIOE, _throwAsIOE, _throwAsIOE, assignIndex, depositSchemaProperty, deserialize, getContextAnnotation, getCreatorIndex, getDeclaringClass, getFullName, getInjectableValueId, getManagedReferenceName, getName, getObjectIdInfo, getPropertyIndex, getType, getValueDeserializer, getValueTypeDeserializer, getWrapperName, hasValueDeserializer, hasValueTypeDeserializer, hasViews, setManagedReferenceName, setObjectIdInfo, setViews, toString, visibleInView, withName, withSimpleName`

### Methods inherited from class com.fasterxml.jackson.databind.introspect.ConcreteBeanPropertyBase

`findFormatOverrides, findPropertyFormat, findPropertyInclusion, getMetadata, isRequired, isVirtual`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### _delegate

    protected final SettableBeanProperty _delegate

Actual property that we use after value construction.

#### _creator

    protected final transient Constructor<?> _creator

Constructor used when deserializing this property. Transient since there is no need to persist; only needed during construction of objects.

#### _annotated

    protected AnnotatedConstructor _annotated

Serializable version of single-arg constructor we use for value instantiation.

### Constructor Detail

#### InnerClassProperty

    public InnerClassProperty(SettableBeanProperty delegate,
                      Constructor<?> ctor)

#### InnerClassProperty

    protected InnerClassProperty(InnerClassProperty src,
                      AnnotatedConstructor ann)

Constructor used with JDK Serialization; needed to handle transient Constructor, wrap/unwrap in/out-of Annotated variant.

#### InnerClassProperty

    protected InnerClassProperty(InnerClassProperty src,
                      JsonDeserializer<?> deser)

#### InnerClassProperty

    protected InnerClassProperty(InnerClassProperty src,
                      PropertyName newName)

### Method Detail

#### withName

    public InnerClassProperty withName(PropertyName newName)

Description copied from class: `SettableBeanProperty`
Fluent factory method for constructing and returning a new instance with specified property name. Note that this method should NOT change configuration of this instance.

Specified by:
  `withName` in class `SettableBeanProperty`
Parameters:
  `newName` - Name to use for the new instance.
Returns:
  Newly constructed instance, if property name differs from the one used for this instance; or 'this' if not.

#### withValueDeserializer

    public InnerClassProperty withValueDeserializer(JsonDeserializer<?> deser)

Description copied from class: `SettableBeanProperty`
Fluent factory method for constructing and returning a new instance with specified value deserializer. Note that this method should NOT change configuration of this instance.

Specified by:
  `withValueDeserializer` in class `SettableBeanProperty`
Parameters:
  `deser` - Deserializer to assign to the new property instance
Returns:
  Newly constructed instance, if value deserializer differs from the one used for this instance; or 'this' if not.

#### fixAccess

    public void fixAccess(DeserializationConfig config)

Description copied from class: `SettableBeanProperty`
Method called to ensure that the mutator has proper access rights to be called, as per configuration. Overridden by implementations that have mutators that require access, fields and setters.

Overrides:
  `fixAccess` in class `SettableBeanProperty`

#### getAnnotation

    public <A extends Annotation> A getAnnotation(Class<A> acls)

Description copied from interface: `BeanProperty`
Method for finding annotation associated with this property; meaning annotation associated with one of entities used to access property.

Note that this method should only be called for custom annotations; access to standard Jackson annotations (or ones supported by alternate `AnnotationIntrospector`s) should be accessed through `AnnotationIntrospector`.

Specified by:
  `getAnnotation` in interface `BeanProperty`
Specified by:
  `getAnnotation` in class `SettableBeanProperty`

#### getMember

    public AnnotatedMember getMember()

Description copied from interface: `BeanProperty`
Method for accessing primary physical entity that represents the property; annotated field, method or constructor property.

Specified by:
  `getMember` in interface `BeanProperty`
Specified by:
  `getMember` in class `SettableBeanProperty`

#### deserializeAndSet

    public void deserializeAndSet(JsonParser jp,
                         DeserializationContext ctxt,
                         Object bean)
                           throws IOException

Description copied from class: `SettableBeanProperty`
Method called to deserialize appropriate value, given parser (and context), and set it using appropriate mechanism. Pre-condition is that passed parser must point to the first token that should be consumed to produce the value (the only value for scalars, multiple for Objects and Arrays).

Specified by:
  `deserializeAndSet` in class `SettableBeanProperty`
Throws:
  `IOException`

#### deserializeSetAndReturn

    public Object deserializeSetAndReturn(JsonParser jp,
                                 DeserializationContext ctxt,
                                 Object instance)
                                   throws IOException

Description copied from class: `SettableBeanProperty`
Alternative to `SettableBeanProperty.deserializeAndSet(com.fasterxml.jackson.core.JsonParser, com.fasterxml.jackson.databind.DeserializationContext, java.lang.Object)` that returns either return value of setter method called (if one is), or null to indicate that no return value is available. Mostly used to support Builder style deserialization.

Specified by:
  `deserializeSetAndReturn` in class `SettableBeanProperty`
Throws:
  `IOException`

#### set

    public final void set(Object instance,
           Object value)
                   throws IOException

Description copied from class: `SettableBeanProperty`
Method called to assign given value to this property, on specified Object.

Note: this is an optional operation, not supported by all implementations, creator-backed properties for example do not support this method.

Specified by:
  `set` in class `SettableBeanProperty`
Throws:
  `IOException`

#### setAndReturn

    public Object setAndReturn(Object instance,
                      Object value)
                        throws IOException

Description copied from class: `SettableBeanProperty`
Method called to assign given value to this property, on specified Object, and return whatever delegating accessor returned (if anything)

Note: this is an optional operation, not supported by all implementations, creator-backed properties for example do not support this method.

Specified by:
  `setAndReturn` in class `SettableBeanProperty`
Throws:
  `IOException`